// Copyright © 2025 ESWIN. All rights reserved.
//
// Beijing ESWIN Computing Technology Co., Ltd and its affiliated companies ("ESWIN") retain
// all intellectual property and proprietary rights in and to this software. Except as expressly
// authorized by ESWIN, no part of the software may be released, copied, distributed, reproduced,
// modified, adapted, translated, or created derivative work of, in whole or in part.

#ifndef ESCL_PERF_API_H
#define ESCL_PERF_API_H

#include "escl_trace.h"

#define ESCL_TRACE_INIT(enable, file_name) escl_trace_init(enable, file_name)
#define ESCL_TRACE_START(tag_name) escl_trace_start(tag_name)
#define ESCL_TRACE_END(tag_name) escl_trace_end(tag_name)
#define ESCL_TRACE_FLUSH() escl_trace_flush()
#define ESCL_TRACE_INSERT(tag_name, starttime, endtime) escl_trace_insert(tag_name, starttime, endtime)
#ifdef __cplusplus
#include <string>
#define ESCL_TRACE_AUTO()       \
    std::string escl_trace_name = std::string(__func__) + "_auto"; \
    ESCL_TRACE_START(escl_trace_name.c_str()); \
    auto __trace_guard_##__LINE__ = std::make_unique<ESCLPerfTracer::EndEventGuard>(escl_trace_name.c_str());
#endif

#endif  // ESCL_PERF_API_H