// Copyright © 2025 ESWIN. All rights reserved.
//
// Beijing ESWIN Computing Technology Co., Ltd and its affiliated companies ("ESWIN") retain
// all intellectual property and proprietary rights in and to this software. Except as expressly
// authorized by ESWIN, no part of the software may be released, copied, distributed, reproduced,
// modified, adapted, translated, or created derivative work of, in whole or in part.

#ifndef __ESCL_COMMON_PLATFORM_H__
#define __ESCL_COMMON_PLATFORM_H__

#if defined(HAVE_STDINT_H)
#include <stdint.h>
#endif /*HAVE_STDINT_H*/
#include <inttypes.h>
/*Windows 9X doesn't be supported. */
#if defined(WIN32) || defined(WINDOWS)
#ifndef _WIN32_WINNT
#define _WIN32_WINNT 0x0500
#endif /*_WIN32_WINNT*/
#include <stdio.h>
#include <assert.h>
#include <windows.h>
#include <process.h>
#include <malloc.h>
#include <tchar.h>
#include <BaseTsd.h>
#include <time.h>
#include <stdlib.h>
#include <wchar.h>
#include <intrin.h>
#elif defined(LINUX) || defined(__linux) || defined(__CYGWIN__)
#if defined(__KERNEL__) && !defined(__CYGWIN__)
#include <stdarg.h>
#include <linux/config.h>
#include <linux/version.h>
#include <linux/module.h>
#if defined(MODVERSIONS)
#include <linux/modversions.h>
#endif /*MODVERSIONS*/
#include <sys/param.h>
#include <sys/system.h>
#include <sys/sysctl.h>
#include <sys/kernel.h>
#include <sys/buf.h>
#include <sys/malloc.h>
#include <sys/conf.h>
#include <sys/disk.h>
#include <sys/devicestat.h>
#include <linux/ioport.h>
#include <linux/init.h>
#include <linux/console.h>
#include <linux/sysrq.h>
#include <linux/circ_buf.h>
#include <linux/delay.h>
#include <linux/interrupt.h>
#include <linux/platform_device.h>
#include <linux/tty.h>
#include <linux/tty_flip.h>
#include <linux/serial_core.h>
#include <asm/io.h>
#include <asm/hardware.h>
#include <asm/irq.h>
#include <asm/arch/hardware.h>
#include <machine/clock.h>
#include <machine/resource.h>
#include <linux/kernel.h>
#include <linux/string.h>
#include <linux/errno.h>
#include <linux/sched.h>
#include <kthread.h>
#include <semaphore.h>
#include <linux/types.h>
#include <linux/kernel.h>
#include <linux/timer.h>
#include <linux/major.h>
#include <asm/io.h>
#include <linux/completion.h> /* For complete() and  wait_for_completion() */
#if (LINUX_VERSION_CODE >= KERNEL_VERSION(4, 3, 0))
#include <linux/membarrier.h> /*> linux 4.3*/
#endif                        /*#if (LINUX_VERSION_CODE >= KERNEL_VERSION(4, 3, 0))*/
#else                         /* !__KERNEL__*/
#include <stdarg.h>
#include <errno.h>
#include <assert.h>
#include <stdio.h>
#include <ctype.h>
#include <string.h>
#include <syslog.h>
#include <signal.h>
#include <sys/wait.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <sys/file.h>
#include <stdarg.h>
#include <stdlib.h>
#include <errno.h>
#ifndef _POSIX_PRIORITY_SCHEDULING
#define _POSIX_PRIORITY_SCHEDULING
#endif /*_POSIX_PRIORITY_SCHEDULING*/
#include <unistd.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <dlfcn.h>
#include <fcntl.h>
#include <termios.h>
#include <errno.h>
#include <dirent.h>
#include <netdb.h>
#include <sys/ioctl.h>
#include <sys/time.h>
#include <pthread.h>
#include <wctype.h>
#include <semaphore.h>
#include <sched.h>
#include <stddef.h> /*                                                                             
#        define __USE_XOPEN2K    *for sched_get_priority_min() and sched_get_priority_max()                    
#        include <semaphore.h>   * The cover up APIs of semaphore must link runtime library with -lrt optional. */
#endif              /* __KERNEL__ */
#elif defined(ECOS) || defined(__ECOS) || defined(__ECOS__)
#if defined(CYGPKG_IO)
#include <cyg/io/io.h>
#endif /* defined(CYGPKG_IO) */
#include <cyg/kernel/kapi.h>
#include <cyg/infra/diag.h>
#include <cyg/hal/hal_io.h>   /* IO macros */
#include <cyg/hal/hal_arch.h> /* Register state info */
#include <cyg/hal/hal_intr.h> /* HAL interrupt macros */
#include <cyg/hal/drv_api.h>
#ifdef CYGPKG_KERNEL
#include <pkgconf/kernel.h> /* Configuration header */
#include <cyg/kernel/kapi.h>
#endif
#include <cyg/hal/hal_if.h>
#else /* WIN32  */
#error "Unsupports OS."
#endif /* WIN32 */

#endif /* __ESCL_COMMON_PLATFORM_H__ */