
// Copyright © 2025 ESWIN. All rights reserved.
//
// Beijing ESWIN Computing Technology Co., Ltd and its affiliated companies ("ESWIN") retain
// all intellectual property and proprietary rights in and to this software. Except as expressly
// authorized by ESWIN, no part of the software may be released, copied, distributed, reproduced,
// modified, adapted, translated, or created derivative work of, in whole or in part.

#ifndef __ESWIN_PLATFORM_ERROR_H__
#define __ESWIN_PLATFORM_ERROR_H__

#include "escl_status.h"

#define ESCL_PLATFORM_ERROR_BASE ESCL_DEF_ERR(ESCL_ID_PLATFORM, ESCL_ERR_LEVEL_ERROR, 0)
#define ESCL_PLATFORM_ERROR_NUM(X) (ESCL_PLATFORM_ERROR_BASE + X)

#define ESCL_PLATFORM_ERROR_INIT_FAILED ESCL_PLATFORM_ERROR_NUM(1)
#define ESCL_PLATFORM_ERROR_FINALIZE_FAILED ESCL_PLATFORM_ERROR_NUM(2)
#define ESCL_PLATFORM_ERROR_DEVICE_NOT_AVAILABLE ESCL_PLATFORM_ERROR_NUM(3)
#define ESCL_PLATFORM_ERROR_DEVICE_ALLOC_FAILED ESCL_PLATFORM_ERROR_NUM(4)
#define ESCL_PLATFORM_ERROR_DEVICE_INIT_ENDPOINT_FAILED ESCL_PLATFORM_ERROR_NUM(5)
#define ESCL_PLATFORM_ERROR_DEVICE_HDMA_INIT_FAILED ESCL_PLATFORM_ERROR_NUM(6)
#define ESCL_PLATFORM_ERROR_SYNC_DEVICE_FAILED ESCL_PLATFORM_ERROR_NUM(7)
#define ESCL_PLATFORM_ERROR_GET_DEVICE_COUNT_FAILED ESCL_PLATFORM_ERROR_NUM(8)
#define ESCL_PLATFORM_ERROR_RESET_DEVICE_FAILED ESCL_PLATFORM_ERROR_NUM(9)
#define ESCL_PLATFORM_ERROR_CREATE_CONTEXT_FOR_DEVICE_FAILED ESCL_PLATFORM_ERROR_NUM(10)
#define ESCL_PLATFORM_ERROR_CREATE_CONTEXT_FAILED ESCL_PLATFORM_ERROR_NUM(11)
#define ESCL_PLATFORM_ERROR_GET_CONTEXT_FAILED ESCL_PLATFORM_ERROR_NUM(12)
#define ESCL_PLATFORM_ERROR_SET_CONTEXT_FAILED ESCL_PLATFORM_ERROR_NUM(13)
#define ESCL_PLATFORM_ERROR_CREATE_STREAM_FAILED ESCL_PLATFORM_ERROR_NUM(14)
#define ESCL_PLATFORM_ERROR_CREATE_STREAM_FOR_DEVICE_FAILED ESCL_PLATFORM_ERROR_NUM(15)
#define ESCL_PLATFORM_ERROR_DESTORY_STREAM_FAILED ESCL_PLATFORM_ERROR_NUM(16)
#define ESCL_PLATFORM_ERROR_DESTORY_STREAM_FOR_STREAM_FAILED ESCL_PLATFORM_ERROR_NUM(17)
#define ESCL_PLATFORM_ERROR_DESTORY_CONTEXT_FAILED ESCL_PLATFORM_ERROR_NUM(18)
#define ESCL_PLATFORM_ERROR_SYNC_STREAM_FOR_CONTEXT_FAILED ESCL_PLATFORM_ERROR_NUM(19)
#define ESCL_PLATFORM_ERROR_HDMA_INIT_FAILED ESCL_PLATFORM_ERROR_NUM(20)
#define ESCL_PLATFORM_ERROR_HDMA_MEMCPY_FAILED ESCL_PLATFORM_ERROR_NUM(21)
#define ESCL_PLATFORM_ERROR_HDMA_MEMSET_FAILED ESCL_PLATFORM_ERROR_NUM(22)
#define ESCL_PLATFORM_ERROR_INVALID_PARAM ESCL_PLATFORM_ERROR_NUM(23)
#define ESCL_PLATFORM_ERROR_NOT_INITIALIZED ESCL_PLATFORM_ERROR_NUM(24)
#define ESCL_PLATFORM_ERROR_NO_CURRENT_CONTEXT ESCL_PLATFORM_ERROR_NUM(25)
#define ESCL_PLATFORM_ERROR_NO_CURRENT_DEVICE ESCL_PLATFORM_ERROR_NUM(26)
#define ESCL_PLATFORM_ERROR_RPC_CLIENT_INIT_FAILED ESCL_PLATFORM_ERROR_NUM(27)
#define ESCL_PLATFORM_ERROR_RPC_CREATE_STREAM_FAILED ESCL_PLATFORM_ERROR_NUM(28)
#define ESCL_PLATFORM_ERROR_STREAM_OUT_LIMITS ESCL_PLATFORM_ERROR_NUM(29)
#define ESCL_PLATFORM_ERROR_SET_CURRENT_CONTEXT_FAILED ESCL_PLATFORM_ERROR_NUM(30)
#define ESCL_PLATFORM_ERROR_EVENT_CONTEXT_FAILED ESCL_PLATFORM_ERROR_NUM(31)
#define ESCL_PLATFORM_ERROR_DESTORY_EVENT_FAILED ESCL_PLATFORM_ERROR_NUM(32)
#define ESCL_PLATFORM_ERROR_CB_TID_BIND_FAILED ESCL_PLATFORM_ERROR_NUM(33)
#define ESCL_PLATFORM_ERROR_EVENT_TIME_FAILED ESCL_PLATFORM_ERROR_NUM(34)

#endif